//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "OpenMailDlgs.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOpenMailDlg *OpenMailDlg;
//---------------------------------------------------------------------------
AnsiString __fastcall OpenMailQueue(TForm *Owner)
{
   OpenMailDlg = new TOpenMailDlg(Owner,MailQueue);
   AnsiString msgname = OpenMailDlg->Execute();
   delete OpenMailDlg;
   return msgname;
}
//---------------------------------------------------------------------------
AnsiString __fastcall OpenSentMail(TForm *Owner)
{
   OpenMailDlg = new TOpenMailDlg(Owner,SentMail);
   AnsiString msgname = OpenMailDlg->Execute();
   delete OpenMailDlg;
   return msgname;
}
//---------------------------------------------------------------------------
__fastcall TOpenMailDlg::TOpenMailDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TOpenMailDlg::TOpenMailDlg(TComponent* Owner, AnsiString DataKey)
	: TForm(Owner)
{
   datakey = DataKey;
   Global->CenterDialog(this,Owner);
   //if (datakey==MailQueue) Global->DB->LoadMessageNames("Mail Queue",ItemsBox->Items);
   //else Global->DB->LoadMessageNames(datakey,ItemsBox->Items);
   Global->DB->LoadMessageNames(datakey,ItemsBox->Items);
   SendBtn->Enabled = ItemsBox->Items->Count;
   LookinBox->Items->Add(datakey);
   LookinBox->ItemIndex = 0;
   sendmail = false;
}
//---------------------------------------------------------------------------
AnsiString TOpenMailDlg::Execute()
{
   ShowModal();
   int index = ItemsBox->ItemIndex;
   if (ModalResult==mrOk && index>=0)
      msgname = ItemsBox->Items->Strings[index];
   return msgname;
}
//---------------------------------------------------------------------------
void __fastcall TOpenMailDlg::ItemsBoxClick(TObject *Sender)
{
   if (ItemsBox->ItemIndex>=0) DeleteBtn->Enabled = OkBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TOpenMailDlg::DeleteBtnClick(TObject *Sender)
{
   if (ConfirmBox(this,"Delete the current message?",MB_OKCANCEL))
   {
      AnsiString name = ItemsBox->Items->Strings[ItemsBox->ItemIndex];
      Global->DB->DelMessage(SentMail,name);
   }
}
//---------------------------------------------------------------------------
void __fastcall TOpenMailDlg::SendBtnClick(TObject *Sender)
{
   if (ConfirmBox(this,"Send all queued mail now?",MB_OKCANCEL)==IDOK)
   {
      sendmail = true; Sleep(150);
      ModalResult = mrOk;
   }
}
//---------------------------------------------------------------------------
void __fastcall TOpenMailDlg::PopupMenuPopup(TObject *Sender)
{
   PopupDeleteItem->Enabled = ItemsBox->ItemIndex>=0;
   PopupSendItem->Visible = datakey==MailQueue;
}
//---------------------------------------------------------------------------
void __fastcall TOpenMailDlg::ItemsBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
   AnsiString d,t,r,s,x,line = ItemsBox->Items->Strings[Index];
   d = Global->GetToken(0,line,"");
   t = Global->GetToken(1,line,"");
   t = Global->GetToken(0,t,":")+":"+Global->GetToken(1,t,":");
   r = Global->GetToken(2,line,"");
   s = Global->GetToken(3,line,"");
   line = d+"  "+t+"  "+r+"  "+s;
   TCanvas *canvas = ItemsBox->Canvas;
   canvas->FillRect(Rect);
   canvas->TextRect(Rect,Rect.Left+2,Rect.Top,line);
}
//---------------------------------------------------------------------------