# ---------------------------------------------------------------------------
VERSION = BCB.01
# ---------------------------------------------------------------------------
!ifndef BCB
BCB = $(MAKEDIR)\..
!endif
# ---------------------------------------------------------------------------
PROJECT = QSPGP.dll
OBJFILES = QSPGP.obj PgpRecipDlgs.obj PgpPassEx.obj PgpDlgs.obj WipeDlgs.obj \
   View.obj PGPbuffers.obj Mixmaster.obj Fmxutils.obj QSpgpVer.obj FileMan.obj \
   HeadMan.obj PgpFiles.obj Global.obj PgpMsg.obj pgpdb.obj pgp.obj PgpCache.obj \
   PgpSdk1.obj
RESFILES = QSPGP.res
RESDEPEN = $(RESFILES) PgpRecipDlgs.dfm PgpPassEx.dfm PgpDlgs.dfm WipeDlgs.dfm \
   View.dfm
LIBFILES = zlib.LIB
DEFFILE =
# ---------------------------------------------------------------------------
CFLAG1 = -WD -Od -Hc -w -k -r- -y -v -vi- -c -a4 -b- -w-par -w-inl -Vx -Ve -x
CFLAG2 = -DPGP_WIN32 \
   -I.\sdk\1.7.8\headers;$(BCB)\lib\ics\delphi\vc32;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\misc \
   -H=$(BCB)\lib\vcld.csm 
PFLAGS = -AWinTypes=Windows;WinProcs=Windows;DbiTypes=BDE;DbiProcs=BDE;DbiErrs=BDE \
   -DPGP_WIN32 \
   -U.;$(BCB)\lib\ics\delphi\vc32;$(BCB)\lib\obj;$(BCB)\lib;$(BCB)\lib\misc \
   -I.\sdk\1.7.8\headers;$(BCB)\lib\ics\delphi\vc32;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\misc \
   -v -$Y -$W -$O- -JPHNV -M
RFLAGS = -DPGP_WIN32 \
   -i.\sdk\1.7.8\headers;$(BCB)\lib\ics\delphi\vc32;$(BCB)\include;$(BCB)\include\vcl;$(BCB)\lib\misc \
   PGP_WIN32 
LFLAGS = -L.;$(BCB)\lib\ics\delphi\vc32;$(BCB)\lib\obj;$(BCB)\lib;$(BCB)\lib\misc \
   -aa -Tpd -x -v -V4.0
IFLAGS =
LINKER = ilink32
# ---------------------------------------------------------------------------
ALLOBJ = c0d32.obj $(OBJFILES)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) vcl.lib import32.lib cp32mt.lib
# ---------------------------------------------------------------------------
.autodepend

$(PROJECT): $(OBJFILES) $(RESDEPEN) $(DEFFILE)
    $(BCB)\BIN\$(LINKER) @&&!
    $(LFLAGS) +
    $(ALLOBJ), +
    $(PROJECT),, +
    $(ALLLIB), +
    $(DEFFILE), +
    $(ALLRES)
!

.pas.hpp:
    $(BCB)\BIN\dcc32 $(PFLAGS) { $** }

.pas.obj:
    $(BCB)\BIN\dcc32 $(PFLAGS) { $** }

.cpp.obj:
    $(BCB)\BIN\bcc32 $(CFLAG1) $(CFLAG2) -o$* $*

.c.obj:
    $(BCB)\BIN\bcc32 $(CFLAG1) $(CFLAG2) -o$* $**

.rc.res:
    $(BCB)\BIN\brcc32 $(RFLAGS) $<
#-----------------------------------------------------------------------------

