//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "pgpmail.h"
#include "pgpfiles.h"
#include "fileman.h"
#include "headman.h"
#include "cyberpunk.h"
#include "wipedlgs.h"
#include "global.h"
#include "view.h"
HINSTANCE hPgpLib=NULL;
//int pgpcnt=0;
//---------------------------------------------------------------------------
bool __fastcall HasPgp()
{
//   pgpcnt++;
//MsgBoxHwnd(NULL,s((int)hPgpLib),s(pgpcnt),MB_OK);
   return hPgpLib!=NULL;
}
//---------------------------------------------------------------------------
bool __fastcall HasPgpSdk()
{
   HASPGPSDK hassdk;
   if (hPgpLib && (hassdk=(HASPGPSDK)GetProcAddress(hPgpLib,"@HasPgpSdk"))!=NULL)
      return (hassdk)();
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   PGPINIT pgpinit;
   if ((pgpinit = (PGPINIT)GetProcAddress(hPgpLib,"@PgpInit"))!=NULL)
   {
     (pgpinit)(HMixLib,HSSLLib,MainForm,AppHandle);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall PgpShutDown()
{
   PGPSHUTDOWN pgpshutdown;
   if ((pgpshutdown = (PGPSHUTDOWN)GetProcAddress(hPgpLib,"@pgpshutdown"))!=NULL)
       (pgpshutdown)();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   GET_PGPLIBNAME getpgplibname;
   if ((getpgplibname = (GET_PGPLIBNAME)GetProcAddress(hPgpLib,"@GetPgpLibName"))!=NULL)
      return (getpgplibname)();
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   GET_PGPLIBVERSION getpgplibversion;
   if ((getpgplibversion = (GET_PGPLIBVERSION)GetProcAddress(hPgpLib,"@GetPgpLibVersion"))!=NULL)
      return (getpgplibversion)();
   return "";
}
//---------------------------------------------------------------------------
void  __fastcall PgpClearPassphraseCache()
{
   PGP_CLEARPASSPHRASECACHE clrcache;
   if ((clrcache = (PGP_CLEARPASSPHRASECACHE)GetProcAddress(hPgpLib,"@PgpClearPassphraseCache"))!=NULL)
      (clrcache)();
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   PGP_SIGNMESSAGE pgp_signmessage;
   if ((pgp_signmessage = (PGP_SIGNMESSAGE)GetProcAddress(hPgpLib,"@PgpSignMessage"))!=NULL)
      return (char*)(pgp_signmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   PGP_ENCRYPTMESSAGE pgp_encryptmessage;
   if ((pgp_encryptmessage = (PGP_ENCRYPTMESSAGE)GetProcAddress(hPgpLib,"@PgpEncryptMessage"))!=NULL)
      return (char*)(pgp_encryptmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   PGP_ENCRYPTSIGNMESSAGE pgp_encryptsignmessage;
   if ((pgp_encryptsignmessage = (PGP_ENCRYPTSIGNMESSAGE)GetProcAddress(hPgpLib,"@PgpEncryptSignMessage"))!=NULL)
      return (char*)(pgp_encryptsignmessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
bool  __fastcall PgpGetEncryptList(TForm *Owner, TStrings *Recips, bool CanConv)
{
   PGP_GETENCRYPTLIST pgp_getenclist;
   if ((pgp_getenclist = (PGP_GETENCRYPTLIST)GetProcAddress(hPgpLib,"@PgpGetEncryptList"))!=NULL)
      return (bool)(pgp_getenclist)(Owner, Recips, CanConv);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PgpIsConventional(char* Message)
{
   PGP_ISCONVENTIONAL pgp_isconventional;
   if ((pgp_isconventional = (PGP_ISCONVENTIONAL)GetProcAddress(hPgpLib,"@PgpIsConventional"))!=NULL)
      return (bool)(pgp_isconventional)(Message);
   return false;
}
//---------------------------------------------------------------------------
char* __fastcall PgpDecryptVerifyMessage(char *Message, bool ForceDialog)
{
   PGP_DECRYPTVERIFYMESSAGE pgp_decryptverifymessage;
   if ((pgp_decryptverifymessage = (PGP_DECRYPTVERIFYMESSAGE)GetProcAddress(hPgpLib,"@PgpDecryptVerifyMessage"))!=NULL)
      return (char*)(pgp_decryptverifymessage)(Message,ForceDialog);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpVerifyMessage(char *Message)
{
   PGP_VERIFYMESSAGE pgp_verifymessage;
   if ((pgp_verifymessage = (PGP_VERIFYMESSAGE)GetProcAddress(hPgpLib,"@PgpVerifyMessage"))!=NULL)
      return (char*)(pgp_verifymessage)(Message);
   return NULL;
}
//---------------------------------------------------------------------------
bool  __fastcall PgpCheckPGP6NeedsUpdate()
{
   PGP_CHECKPGP6NEEDSUPDATE check;
   if ((check = (PGP_CHECKPGP6NEEDSUPDATE)GetProcAddress(hPgpLib,"@PgpCheckPGP6NeedsUpdate"))!=NULL)
      return check();
   return false;
}
//---------------------------------------------------------------------------
bool  __fastcall PgpUpdateQSKeyrings()
{
   PGP_UPDATEQSKEYRINGS update;
   if ((update = (PGP_UPDATEQSKEYRINGS)GetProcAddress(hPgpLib,"@PgpUpdateQSKeyrings"))!=NULL)
     return update;
   return false;
}
//---------------------------------------------------------------------------
char* __fastcall PgpPubringPkr()
{
   PGP_PUBRINGPKR pubring;
   if ((pubring = (PGP_PUBRINGPKR)GetProcAddress(hPgpLib,"@PgpPubringPkr"))!=NULL)
      return (pubring)();
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpSecringSkr()
{
   PGP_SECRINGSKR secring;
   if ((secring = (PGP_SECRINGSKR)GetProcAddress(hPgpLib,"@PgpSecringSkr"))!=NULL)
      return (secring)();
   return "";
}
//---------------------------------------------------------------------------
/*char* __fastcall PgpArmorBlockToArmorKeysCpk(char *Keys)
{
   PGP_GETARMORKEYS pgp_getarmorkeyscpk;
   if ((pgp_getarmorkeyscpk = (PGP_GETARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorBlockToArmorKeysCpk"))!=NULL)
      return (pgp_getarmorkeyscpk)(Keys);
   return "";
}
//---------------------------------------------------------------------------
int __fastcall PgpDearmor(BUFFER *in, BUFFER *out)
{
   PGP_DEARMOR dearmor;
   if ((dearmor = (PGP_DEARMOR)GetProcAddress(hPgpLib,"@PgpDearmor"))!=NULL)
      return (int)(dearmor)(in,out);
   return false;
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeys(char *Keys)
{
   PGP_GETARMORKEYS pgp_getarmorkeys;
   if ((pgp_getarmorkeys = (PGP_GETARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorBlockToArmorKeys"))!=NULL)
      return (pgp_getarmorkeys)(Keys);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeysPlus(char *Keys)
{
   PGP_GETARMORKEYS pgp_getarmorkeys;
   if ((pgp_getarmorkeys = (PGP_GETARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorBlockToArmorKeysPlus"))!=NULL)
      return (pgp_getarmorkeys)(Keys);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeysCpkDesc(char *Keys)
{
   PGP_GETARMORKEYS pgp_getarmorkeyscpkdesc;
   if ((pgp_getarmorkeyscpkdesc = (PGP_GETARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorBlockToArmorKeysCpkDesc"))!=NULL)
      return (pgp_getarmorkeyscpkdesc)(Keys);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorKeysToArmorBlock(char *Keys)
{
   PGP_PUTARMORKEYS pgp_putarmorkeys;
   if ((pgp_putarmorkeys = (PGP_PUTARMORKEYS)GetProcAddress(hPgpLib,"@PgpArmorKeysToArmorBlock"))!=NULL)
      return (pgp_putarmorkeys)(Keys);
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetUserIdsKeyIds(char *KeyFile)
{
   PGP_GETKEYS_IDS pgp_getkeys_ids;
   if ((pgp_getkeys_ids = (PGP_GETKEYS_IDS)GetProcAddress(hPgpLib,"@PgpGetUserIdsKeyIds"))!=NULL)
      return (char*)(pgp_getkeys_ids)(KeyFile);
   return NULL;
}
//---------------------------------------------------------------------------
bool  __fastcall GenerateType1List(char *KeyDoc)
{
   GENERATETYPE1LIST generatetype1list;
   if ((generatetype1list = (GENERATETYPE1LIST)GetProcAddress(hPgpLib,"@GenerateType1List"))!=NULL)
      return (generatetype1list)(KeyDoc);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc, char *Type1)
{
   PGP_GETNEWKEYS pgp_getnewkeys;
   if ((pgp_getnewkeys = (PGP_GETNEWKEYS)GetProcAddress(hPgpLib,"@PgpGetNewRemailerKeys"))!=NULL)
      return (pgp_getnewkeys)(KeyDoc,Type1);
   return NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc, char *Type1)
{
   PGP_ADDNEWKEYS pgp_addnewkeys;
   if ((pgp_addnewkeys = (PGP_ADDNEWKEYS)GetProcAddress(hPgpLib,"@PgpAddNewRemailerKeys"))!=NULL)
      return (pgp_addnewkeys)(KeyDoc,Type1);
   return "";
}
//---------------------------------------------------------------------------
void __fastcall OpenPgpKeysWindow(TForm *Owner)
{
   PGP_OPENKEYSWIN openkeys;
   if ((openkeys = (PGP_OPENKEYSWIN)GetProcAddress(hPgpLib,"@OpenPgpKeysWindow"))!=NULL)
      (void)(openkeys)();
//   if (!PgpKeyWin) PgpKeyWin = new TPgpKeyWin(Owner,PgpPublicRing(),PgpSecretRing());
//   else PgpKeyWin->BringToFront();
}
//---------------------------------------------------------------------------
bool __fastcall PgpImportKeysReplace(char *importfile, char *pubring,
   char *secring, bool deleteImportfile)
{
   PGP_IMPORTREPLACE pgp_importreplace;
   if ((pgp_importreplace = (PGP_IMPORTREPLACE)GetProcAddress(hPgpLib,"@PgpImportKeysReplace"))!=NULL)
      return (bool)(pgp_importreplace)(importfile,pubring,secring,deleteImportfile);
   return false;
}
//---------------------------------------------------------------------------
bool  __fastcall PgpImportKeysAddNew(char *importfile, char *pubring,
   char *secring, bool deleteImportfile)
{
   PGP_IMPORTADDNEW pgp_importaddnew;
   if ((pgp_importaddnew = (PGP_IMPORTADDNEW)GetProcAddress(hPgpLib,"@PgpImportKeysAddNew"))!=NULL)
      return (bool)(pgp_importaddnew)(importfile,pubring,secring,deleteImportfile);
   return false;
}*/
//---------------------------------------------------------------------------



